

if {$::tcl_platform(platform) eq "windows"} {
set tcl_wordchars "\\S"
set tcl_nonwordchars "\\s"
} else {
set tcl_wordchars "\\w"
set tcl_nonwordchars "\\W"
}


proc tcl_wordBreakAfter {str start} {
global tcl_nonwordchars tcl_wordchars
set str [string range $str $start end]
if {[regexp -indices "$tcl_wordchars$tcl_nonwordchars|$tcl_nonwordchars$tcl_wordchars" $str result]} {
return [expr {[lindex $result 1] + $start}]
}
return -1
}


proc tcl_wordBreakBefore {str start} {
global tcl_nonwordchars tcl_wordchars
if {$start eq "end"} {
set start [string length $str]
}
if {[regexp -indices "^.*($tcl_wordchars$tcl_nonwordchars|$tcl_nonwordchars$tcl_wordchars)" [string range $str 0 $start] result]} {
return [lindex $result 1]
}
return -1
}


proc tcl_endOfWord {str start} {
global tcl_nonwordchars tcl_wordchars
if {[regexp -indices "$tcl_nonwordchars*$tcl_wordchars+$tcl_nonwordchars"  [string range $str $start end] result]} {
return [expr {[lindex $result 1] + $start}]
}
return -1
}


proc tcl_startOfNextWord {str start} {
global tcl_nonwordchars tcl_wordchars
if {[regexp -indices "$tcl_wordchars*$tcl_nonwordchars+$tcl_wordchars"  [string range $str $start end] result]} {
return [expr {[lindex $result 1] + $start}]
}
return -1
}


proc tcl_startOfPreviousWord {str start} {
global tcl_nonwordchars tcl_wordchars
if {$start eq "end"} {
set start [string length $str]
}
if {[regexp -indices  "$tcl_nonwordchars*($tcl_wordchars+)$tcl_nonwordchars*\$"  [string range $str 0 [expr {$start - 1}]] result word]} {
return [lindex $word 0]
}
return -1
}
